#!/usr/bin/env python
# -*- coding: utf-8 -*-


import json
import sys
import os
import re

JSONSTATS = "../raw_json_indent"
K = 11
if len(sys.argv)>1 and sys.argv[1]!=None: JSONSTATS = sys.argv[1]
if len(sys.argv)>2 and sys.argv[2]!=None: K = int(sys.argv[2])


def writeDict(orig_file , name , array ):
	filename = orig_file+name
	f = open( filename , "w" )
	f.write( json.dumps( array , indent=1) )
	f.close()
	return filename

def openJSON( filename ):
	# print("reading...")
	f = open( filename , "r" )
	data = json.load( f )
	f.close()
	return data



def iter_folder( FOLDER ):

	V = {}
	suma = 0

	#D = {}
	D_c = 0
	D_s2i = {}
	D_i2s = {}

	query = 'ls '+FOLDER+"/*"
	pubs_folder = os.popen(  query  )

	elems = []
	for f_ in pubs_folder:
		filepath = f_.replace("\n","")
		print(filepath)
		P = openJSON(filepath)
		D = {}


		for i in P:
			p = P[i]

			if "MH" in p:
				termsID = {}
				# print( p["PMID"][0]  )
				# print( "\t",p["MH"]  )
				terms = p["MH"]
				for t in terms:
					
					the_ID = -1

					if t not in D_s2i:
						D_c += 1
						the_ID = D_c
					else:
						the_ID = D_s2i[t]
					
					D_s2i[t] = the_ID
					D_i2s[the_ID] = t

					termsID[the_ID] = True
				termsID = sorted( list(termsID.keys()) )

				D[p["PMID"][0]] = termsID


		try: 
			YEAR = re.search(r"\d{4}", filepath).group(0)
		except: 
			YEAR = 'None'
			pass

		print( YEAR )
		FILEPATH = "json_meshfinal/"+YEAR
		writeDict( FILEPATH , ".json" , D )
	
	writeDict( "dict_" , "int2str.json" , D_i2s)
	writeDict( "dict_" , "str2int.json" , D_s2i)




	return V



D = iter_folder( JSONSTATS )
